"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/helptips/onboardingtips.js
var onboardingtips_exports = {};
__export(onboardingtips_exports, {
  DashboardOnboardingPendings: () => DashboardOnboardingPendings,
  DashboardOnboardingState: () => DashboardOnboardingState,
  DeploymentUploadFinished: () => DeploymentUploadFinished,
  DeploymentsInprogress: () => DeploymentsInprogress,
  DeploymentsPast: () => DeploymentsPast,
  DeploymentsPastCompletedFailure: () => DeploymentsPastCompletedFailure,
  DevicePendingTip: () => DevicePendingTip,
  DevicesAcceptedOnboarding: () => DevicesAcceptedOnboarding,
  DevicesDeployReleaseOnboarding: () => DevicesDeployReleaseOnboarding,
  DevicesPendingAcceptingOnboarding: () => DevicesPendingAcceptingOnboarding,
  DevicesPendingDelayed: () => DevicesPendingDelayed,
  GetStartedTip: () => GetStartedTip,
  SchedulingAllDevicesSelection: () => SchedulingAllDevicesSelection,
  SchedulingArtifactSelection: () => SchedulingArtifactSelection,
  SchedulingGroupSelection: () => SchedulingGroupSelection,
  SchedulingReleaseToDevices: () => SchedulingReleaseToDevices
});
module.exports = __toCommonJS(onboardingtips_exports);
var import_react2 = __toESM(require("react"), 1);
var import_react_redux2 = require("react-redux");
var import_icons_material2 = require("@mui/icons-material");
var import_material2 = require("@mui/material");
var import_actions2 = __toESM(require("@northern.tech/store/actions"), 1);
var import_constants2 = require("@northern.tech/store/constants");
var import_thunks = require("@northern.tech/store/thunks");

// src/helptips/baseonboardingtip.js
var import_react = __toESM(require("react"), 1);
var import_react_redux = require("react-redux");
var import_icons_material = require("@mui/icons-material");
var import_material = require("@mui/material");
var import_mui = require("tss-react/mui");
var import_common_ui = require("@northern.tech/common-ui");
var import_actions = __toESM(require("@northern.tech/store/actions"), 1);
var import_constants = require("@northern.tech/store/constants");
var import_helpers = require("@northern.tech/utils/helpers");
var import_tracking = __toESM(require("@northern.tech/utils/tracking"), 1);
var import_jsx_runtime = require("react/jsx-runtime");
var { setShowDismissOnboardingTipsDialog } = import_actions.default;
var iconWidth = 30;
var orientations = {
  top: {
    arrow: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_icons_material.ArrowUpward, {}),
    placement: "bottom",
    offsetStyle: (style) => {
      style.left = style.left - iconWidth / 2;
      return style;
    }
  },
  right: {
    arrow: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_icons_material.ArrowBack, {}),
    placement: "right",
    offsetStyle: (style) => {
      style.top = style.top - iconWidth / 2;
      style.left = style.left + iconWidth / 2;
      return style;
    }
  },
  bottom: {
    arrow: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_icons_material.ArrowDownward, {}),
    placement: "top",
    offsetStyle: (style) => {
      style.left = style.left - iconWidth / 2;
      return style;
    }
  },
  left: {
    arrow: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_icons_material.ArrowForward, {}),
    placement: "left",
    offsetStyle: (style) => {
      style.top = style.top - iconWidth / 2;
      return style;
    }
  }
};
var useStyles = (0, import_mui.makeStyles)()((theme) => ({
  root: {
    [`.${import_material.buttonBaseClasses.root}.${import_material.buttonClasses.text}`]: { color: theme.palette.background.paper, paddingRight: 0 }
  }
}));
var BaseOnboardingTooltip = ({ anchor = { left: 0, top: 0 }, icon, children, id = "1", place = "top", ...props }) => {
  const [open, setOpen] = (0, import_react.useState)(false);
  const showDismissHelptipsDialog = (0, import_react_redux.useSelector)((state) => state.onboarding.showTipsDialog);
  const showDeviceConnectionDialog = (0, import_react_redux.useSelector)((state) => state.users.showConnectDeviceDialog);
  const delayTimer = (0, import_react.useRef)();
  const { classes } = useStyles();
  (0, import_react.useEffect)(() => {
    import_tracking.default.event({ category: "onboarding", action: id });
    clearTimeout(delayTimer.current);
    delayTimer.current = setTimeout(() => setOpen(true), import_constants.TIMEOUTS.debounceShort);
    return () => {
      clearTimeout(delayTimer.current);
    };
  }, [id]);
  const toggleVisibility = () => setOpen(import_helpers.toggle);
  const hide = () => setOpen(false);
  if (showDismissHelptipsDialog || showDeviceConnectionDialog) {
    return null;
  }
  const orientation = orientations[place];
  const style = orientation.offsetStyle({ left: anchor.left, top: anchor.top, overflow: "initial" });
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    import_common_ui.OnboardingTooltip,
    {
      disableFocusListener: true,
      disableHoverListener: true,
      disableTouchListener: true,
      id,
      onClose: hide,
      open,
      placement: orientation.placement,
      PopperProps: {
        className: classes.root,
        disablePortal: true,
        popperOptions: {
          strategy: "fixed",
          modifiers: [
            { name: "flip", enabled: false },
            { name: "preventOverflow", enabled: true, options: { boundary: window, altBoundary: false } }
          ]
        }
      },
      title: children,
      className: classes.root,
      ...props,
      children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className: "onboard-tip", onClick: toggleVisibility, style, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className: `tooltip onboard-icon ${orientation.placement}`, children: icon ?? orientation.arrow }) })
    }
  );
};
var BaseOnboardingTip = ({ anchor, icon, component, place, id, ...others }) => {
  const dispatch = (0, import_react_redux.useDispatch)();
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(BaseOnboardingTooltip, { anchor, icon, place, id, children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("div", { className: "content", children: [
    import_react.default.cloneElement(component, others),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("b", { className: "clickable", onClick: () => dispatch(setShowDismissOnboardingTipsDialog(true)), children: "Dismiss the tutorial" }) })
  ] }) });
};

// src/helptips/onboardingtips.js
var import_jsx_runtime2 = require("react/jsx-runtime");
var { setShowConnectingDialog, setShowDismissOnboardingTipsDialog: setShowDismissOnboardingTipsDialog2 } = import_actions2.default;
var DevicePendingTip = (props) => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
  BaseOnboardingTip,
  {
    icon: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_icons_material2.Schedule, {}),
    component: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { children: 'If you followed the steps in "Connecting a device", your device will show here shortly.' }),
    ...props
  }
);
var GetStartedTip = (props) => {
  const dispatch = (0, import_react_redux2.useDispatch)();
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(BaseOnboardingTooltip, { ...props, children: /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "margin-top", style: { marginBottom: -12 }, children: [
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("p", { children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("b", { children: "Welcome to Mender!" }) }),
    "We can help you get started with connecting your first device and deploying an update to it.",
    /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "flexbox center-aligned margin-top-small space-between", children: [
      /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("b", { className: "clickable slightly-smaller", onClick: () => dispatch(setShowDismissOnboardingTipsDialog2(true)), children: "No thanks, I don't need help" }),
      /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_material2.Button, { onClick: () => dispatch(setShowConnectingDialog(true)), children: "Get started" })
    ] })
  ] }) });
};
var DevicesPendingDelayed = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { children: "If your device still isn't showing, try following the connection steps again or see our documentation for more." });
var DashboardOnboardingState = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { children: "Your device has requested to join the server. Click the row to expand the device details." });
var DevicesPendingAcceptingOnboarding = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { children: [
  "Your device has made a request to join the Mender server. You can inspect its identity details, such as mac address and public key, to verify it is definitely your device.",
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("br", {}),
  "When you are ready, Accept it!"
] });
var DashboardOnboardingPendings = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { children: "Next accept your device" });
var DevicesAcceptedOnboarding = (props) => {
  const dispatch = (0, import_react_redux2.useDispatch)();
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(BaseOnboardingTooltip, { ...props, children: /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "margin-top", style: { marginBottom: -12 }, children: [
    /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { children: [
      /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("p", { children: "Your device is now authenticated and has connected to the server! It's ready to receive updates, report its data and more." }),
      "Would you like to learn how to deploy your first update?"
    ] }),
    /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "flexbox center-aligned margin-top-small space-between", children: [
      /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("b", { className: "clickable slightly-smaller", onClick: () => dispatch(setShowDismissOnboardingTipsDialog2(true)), children: "Dismiss the tutorial" }),
      /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_material2.Button, { onClick: () => dispatch((0, import_thunks.advanceOnboarding)(import_constants2.onboardingSteps.DEVICES_ACCEPTED_ONBOARDING)), children: "Yes, let's deploy!" })
    ] })
  ] }) });
};
var DevicesDeployReleaseOnboarding = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { children: "From the Device actions, choose 'Create a deployment for this device'. You'll deploy an update to the device, using some demo software we have provided." });
var SchedulingArtifactSelection = ({ selectedRelease }) => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { children: `Select the ${selectedRelease.name} release we included.` });
var SchedulingAllDevicesSelection = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { children: [
  "Select 'All devices' for now.",
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("p", { children: "You can learn how to create device groups later." })
] });
var SchedulingGroupSelection = ({ createdGroup }) => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { children: `Select the ${createdGroup} device group you just made.` });
var SchedulingReleaseToDevices = ({ selectedDevice, selectedGroup, selectedRelease }) => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { children: `Create the deployment! This will deploy the ${selectedRelease.name} Artifact to ${selectedDevice ? selectedDevice.id : selectedGroup || import_constants2.ALL_DEVICES}` });
var DeploymentsInprogress = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { children: "Your deployment is in progress. Click to view a report" });
var DeploymentUploadFinished = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { children: "Artifact upload is finished. Click to close the panel" });
var DeploymentsPast = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { children: "Your deployment has finished, click here to view it" });
var DeploymentsPastCompletedFailure = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { children: "Your deployment has finished, but it looks like there was a problem. Click to view the deployment report, where you can see the error log." });
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  DashboardOnboardingPendings,
  DashboardOnboardingState,
  DeploymentUploadFinished,
  DeploymentsInprogress,
  DeploymentsPast,
  DeploymentsPastCompletedFailure,
  DevicePendingTip,
  DevicesAcceptedOnboarding,
  DevicesDeployReleaseOnboarding,
  DevicesPendingAcceptingOnboarding,
  DevicesPendingDelayed,
  GetStartedTip,
  SchedulingAllDevicesSelection,
  SchedulingArtifactSelection,
  SchedulingGroupSelection,
  SchedulingReleaseToDevices
});
//# sourceMappingURL=onboardingtips.cjs.map