import {
  terminalsession_default
} from "./chunk-JK6DJG7G.js";
import {
  UserChange
} from "./chunk-5OY6Q7DK.js";
import {
  FallbackComponent_default
} from "./chunk-OGS64QTN.js";
import {
  deviceconfiguration_default
} from "./chunk-TSCS5CWP.js";
import {
  filetransfer_default
} from "./chunk-TISEN7C7.js";
import {
  portforward_default
} from "./chunk-ZCXF2SVA.js";

// src/auditlogs/EventDetailsDrawerContentMap.jsx
var changeTypes = {
  user: "user",
  device: "device",
  tenant: "tenant"
};
var configChangeDescriptor = {
  set_configuration: "definition",
  deploy_configuration: "deployment"
};
var EventDetailsDrawerContentMap = (item, FallbackComponent = FallbackComponent_default) => {
  const { type } = item.object || {};
  let content = { title: "Entry details", content: FallbackComponent };
  if (type === changeTypes.user) {
    content = { title: `${item.action}d user`, content: UserChange };
  } else if (type === changeTypes.device && item.action.includes("terminal")) {
    content = { title: "Remote session log", content: terminalsession_default };
  } else if (type === changeTypes.device && item.action.includes("file")) {
    content = { title: "File transfer", content: filetransfer_default };
  } else if (type === changeTypes.device && item.action.includes("portforward")) {
    content = { title: "Port forward", content: portforward_default };
  } else if (type === changeTypes.device && item.action.includes("configuration")) {
    content = { title: `Device configuration ${configChangeDescriptor[item.action] || ""}`, content: deviceconfiguration_default };
  } else if (type === changeTypes.device) {
    content = { title: "Device change", content: FallbackComponent };
  } else if (type === changeTypes.tenant) {
    content = { title: `${item.action}d tenant`, content: UserChange };
  }
  return content;
};
var EventDetailsDrawerContentMap_default = EventDetailsDrawerContentMap;

export {
  EventDetailsDrawerContentMap_default
};
//# sourceMappingURL=chunk-LBKNPTMN.js.map